diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
index 6c7bea0b9..5b3f778be 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -16,17 +17,17 @@ public class WorldFeatureGlowstoneB extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         if(!world.isAirBlock(x, y, z))
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Block.netherrack.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
         {
             return false;
         }
-        world.setBlockWithNotify(x, y, z, Block.glowstone.id);
+        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id);
         for(int l = 0; l < 1500; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -64,7 +65,7 @@ public class WorldFeatureGlowstoneB extends WorldFeature
                 {
                     j2 = world.getBlockId(i1, j1, k1 + 1);
                 }
-                if(j2 == Block.glowstone.id)
+                if(j2 == Blocks.GLOWSTONE.id)
                 {
                     l1++;
                 }
@@ -72,7 +73,7 @@ public class WorldFeatureGlowstoneB extends WorldFeature
 
             if(l1 == 1)
             {
-                world.setBlockWithNotify(i1, j1, k1, Block.glowstone.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
index 40d66b808..310080df3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -19,9 +19,9 @@ public class WorldFeatureGrassPatch extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        float f = random.nextFloat() * 3.141593F;
+        float f = random.nextFloat() * MathHelper.PI;
         double d = (float)(x + 8) + (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double d1 = (float)(x + 8) - (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double d2 = (float)(z + 8) + (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
@@ -34,14 +34,14 @@ public class WorldFeatureGrassPatch extends WorldFeature
             double d7 = d4 + ((d5 - d4) * (double)l) / (double)numberOfBlocks;
             double d8 = d2 + ((d3 - d2) * (double)l) / (double)numberOfBlocks;
             double d9 = (random.nextDouble() * (double)numberOfBlocks) / 16D;
-            double d10 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            double d11 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            int i1 = MathHelper.floor_double(d6 - d10 / 2D);
-            int j1 = MathHelper.floor_double(d7 - d11 / 2D);
-            int k1 = MathHelper.floor_double(d8 - d10 / 2D);
-            int l1 = MathHelper.floor_double(d6 + d10 / 2D);
-            int i2 = MathHelper.floor_double(d7 + d11 / 2D);
-            int j2 = MathHelper.floor_double(d8 + d10 / 2D);
+            double d10 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int i1 = MathHelper.floor(d6 - d10 / 2D);
+            int j1 = MathHelper.floor(d7 - d11 / 2D);
+            int k1 = MathHelper.floor(d8 - d10 / 2D);
+            int l1 = MathHelper.floor(d6 + d10 / 2D);
+            int i2 = MathHelper.floor(d7 + d11 / 2D);
+            int j2 = MathHelper.floor(d8 + d10 / 2D);
             for(int k2 = i1; k2 <= l1; k2++)
             {
                 double d12 = (((double)k2 + 0.5D) - d6) / (d10 / 2D);
@@ -61,7 +61,7 @@ public class WorldFeatureGrassPatch extends WorldFeature
                         double d14 = (((double)i3 + 0.5D) - d8) / (d10 / 2D);
                         if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
                         {
-                            if(world.getBlockId(k2, l2, i3) == Block.dirt.id || world.getBlockId(k2, l2, i3) == Block.grass.id)
+                            if(world.getBlockId(k2, l2, i3) == Blocks.DIRT.id || world.getBlockId(k2, l2, i3) == Blocks.GRASS.id)
                                 world.setBlockAndMetadata(k2, l2, i3, blockToPlace, 0);
                         }
                     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index a968365d2..cb2a2efb8 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -2,14 +2,15 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.entity.ChestBlockEntity;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntityChest;
-import net.minecraft.core.block.entity.TileEntityDispenser;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.biome.Biomes;
 
@@ -17,7 +18,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Material, Block,
-//            TileEntityChest, TileEntityMobSpawner, ItemStack, Item
+//            ChestBlockEntity, MobSpawnerBlockEntity, ItemStack, Item
 public class WorldFeatureLabyrinth extends WorldFeature
 {
     public WorldFeatureLabyrinth()
@@ -29,71 +30,71 @@ public class WorldFeatureLabyrinth extends WorldFeature
     boolean treasureGenerated = false;
     boolean libraryGenerated = false;
     boolean isCold = false;
-    int wallBlockA = Block.cobbleStone.id;
-    int wallBlockB = Block.cobbleStoneMossy.id;
-    int brickBlockA = Block.brickStonePolished.id;
-    int brickBlockB = Block.brickStonePolishedMossy.id;
-    int slabBlock = Block.slabStonePolished.id;
+    int wallBlockA = Blocks.COBBLE_STONE.id;
+    int wallBlockB = Blocks.COBBLE_STONE_MOSSY.id;
+    int brickBlockA = Blocks.BRICK_STONE_POLISHED.id;
+    int brickBlockB = Blocks.BRICK_STONE_POLISHED_MOSSY.id;
+    int slabBlock = Blocks.SLAB_STONE_POLISHED.id;
     public ItemStack treasureItem;
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<WeightedRandomLootObject> dispenserLoot;
     public WeightedRandomBag<String> spawnerMonsters;
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z)
+    public boolean place(World world, Random random, int x, int y, int z)
     {
         Biome biome = world.getBlockBiome(x, y, z);
 
         if (biome == Biomes.OVERWORLD_DESERT || biome == Biomes.OVERWORLD_OUTBACK)
         {
-            wallBlockA = Block.sandstone.id;
-            wallBlockB = Block.sandstone.id;
-            brickBlockA = Block.brickSandstone.id;
-            brickBlockB = Block.brickSandstone.id;
-            slabBlock = Block.slabSandstone.id;
+            wallBlockA = Blocks.SANDSTONE.id;
+            wallBlockB = Blocks.SANDSTONE.id;
+            brickBlockA = Blocks.BRICK_SANDSTONE.id;
+            brickBlockB = Blocks.BRICK_SANDSTONE.id;
+            slabBlock = Blocks.SLAB_SANDSTONE.id;
         }
         if (biome == Biomes.OVERWORLD_TAIGA || biome == Biomes.OVERWORLD_TUNDRA || biome == Biomes.OVERWORLD_GLACIER)
         {
-            wallBlockA = Block.permafrost.id;
-            wallBlockB = Block.cobblePermafrost.id;
-            brickBlockA = Block.brickPermafrost.id;
-            brickBlockB = Block.brickPermafrost.id;
+            wallBlockA = Blocks.PERMAFROST.id;
+            wallBlockB = Blocks.COBBLE_PERMAFROST.id;
+            brickBlockA = Blocks.BRICK_PERMAFROST.id;
+            brickBlockB = Blocks.BRICK_PERMAFROST.id;
             isCold = true;
         }
 
         this.chestLoot = new WeightedRandomBag<>();
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.ingotIron.getDefaultStack(), 1, 6), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.ingotGold.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.sulphur.getDefaultStack(), 3, 8), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.diamond.getDefaultStack(), 1, 4), 2);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.foodAppleGold.getDefaultStack()), 1);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.dustRedstone.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 1, 6), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_GOLD.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.SULPHUR.getDefaultStack(), 3, 8), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.DIAMOND.getDefaultStack(), 1, 4), 2);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 1);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 1, 4), 100);
         for (int i = 0; i < 9; i++) {
-            chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Item.record13.id + i])), 1);
+            chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Items.RECORD_13.id + i])), 1);
         }
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.foodApple.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Block.spongeDry.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.handcannonLoaded.getDefaultStack()), 0.5);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.handcannonUnloaded.getDefaultStack()), 4.5);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SPONGE_DRY.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.HANDCANNON_LOADED.getDefaultStack()), 0.5);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.HANDCANNON_UNLOADED.getDefaultStack()), 4.5);
 
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.armorHelmetChainmail.getDefaultStack())
-                        .setRandomMetadata(Item.armorHelmetChainmail.getMaxDamage()/2, Item.armorHelmetChainmail.getMaxDamage()), 20);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack())
+                        .setRandomMetadata(Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()), 20);
 
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.armorChestplateChainmail.getDefaultStack())
-                .setRandomMetadata(Item.armorChestplateChainmail.getMaxDamage()/2, Item.armorChestplateChainmail.getMaxDamage()), 20);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack())
+                .setRandomMetadata(Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()), 20);
 
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.armorLeggingsChainmail.getDefaultStack())
-                .setRandomMetadata(Item.armorLeggingsChainmail.getMaxDamage()/2, Item.armorLeggingsChainmail.getMaxDamage()), 20);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack())
+                .setRandomMetadata(Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()), 20);
 
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.armorBootsChainmail.getDefaultStack())
-                .setRandomMetadata(Item.armorBootsChainmail.getMaxDamage()/2, Item.armorBootsChainmail.getMaxDamage()), 20);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack())
+                .setRandomMetadata(Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()), 20);
 
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.ingotSteelCrude.getDefaultStack()), 10);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_STEEL_CRUDE.getDefaultStack()), 10);
         chestLoot.addEntry(new WeightedRandomLootObject(null), 892);
 
         this.dispenserLoot = new WeightedRandomBag<>();
-        dispenserLoot.addEntry(new WeightedRandomLootObject(Item.ammoArrow.getDefaultStack(), 5, 7), 300);
-        dispenserLoot.addEntry(new WeightedRandomLootObject(Item.ammoArrowGold.getDefaultStack()), 10);
-        dispenserLoot.addEntry(new WeightedRandomLootObject(Item.ammoChargeExplosive.getDefaultStack()), 0.5);
+        dispenserLoot.addEntry(new WeightedRandomLootObject(Items.AMMO_ARROW.getDefaultStack(), 5, 7), 300);
+        dispenserLoot.addEntry(new WeightedRandomLootObject(Items.AMMO_ARROW_GOLD.getDefaultStack()), 10);
+        dispenserLoot.addEntry(new WeightedRandomLootObject(Items.AMMO_CHARGE_EXPLOSIVE.getDefaultStack()), 0.5);
         dispenserLoot.addEntry(new WeightedRandomLootObject(null), 289.5);
 
         this.spawnerMonsters = new WeightedRandomBag<>();
@@ -102,10 +103,10 @@ public class WorldFeatureLabyrinth extends WorldFeature
         if (isCold){
             spawnerMonsters.addEntry("Snowman", 1);
             spawnerMonsters.addEntry("ArmouredZombie", 1);
-            treasureItem = Item.armorBootsIceskates.getDefaultStack();
+            treasureItem = Items.ARMOR_BOOTS_ICESKATES.getDefaultStack();
         } else {
             spawnerMonsters.addEntry("ArmouredZombie", 2);
-            treasureItem = Item.armorQuiverGold.getDefaultStack();
+            treasureItem = Items.ARMOR_QUIVER_GOLD.getDefaultStack();
         }
 
         if(canReplace(world, x, y, z)) {
@@ -141,14 +142,14 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         //generate traps
                         if (!generateTrapOnWall && (xWallCheck || zWallCheck)) {
                             if ((x == blockZ || z == blockZ) && y == blockY) {
-                                world.setBlockWithNotify(x, y, z, Block.motionsensorIdle.id);
-                                world.setBlockWithNotify(x, y - 1, z, Block.dispenserCobbleStone.id);
-                                TileEntityDispenser tileEntityDispenser = (TileEntityDispenser) world.getBlockTileEntity(x, blockY - 1, z);
+                                world.setBlockWithNotify(x, y, z, Blocks.MOTION_SENSOR_IDLE.id);
+                                world.setBlockWithNotify(x, y - 1, z, Blocks.DISPENSER_COBBLE_STONE.id);
+                                DispenserBlockEntity tileEntityDispenser = (DispenserBlockEntity) world.getBlockEntity(x, blockY - 1, z);
                                 int k4 = 0;
                                 while (k4 < 3) {
                                     ItemStack itemstack = pickDispenserLootItem(random);
                                     if (itemstack != null)
-                                        tileEntityDispenser.setInventorySlotContents(random.nextInt(tileEntityDispenser.getSizeInventory()), itemstack);
+                                        tileEntityDispenser.setItem(random.nextInt(tileEntityDispenser.getContainerSize()), itemstack);
                                     k4++;
                                 }
                                 generateTrapOnWall = true;
@@ -186,7 +187,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         if (yWallCheck) {
                             world.setBlockWithNotify(x, y, z, wallBlockB);
                             if(dungeonSize >= 10)
-                                world.setBlockWithNotify(x, y+1, z, Block.spikes.id);
+                                world.setBlockWithNotify(x, y+1, z, Blocks.SPIKES.id);
                         }
                         else if (x != blockX && z != blockZ && random.nextInt(20) == 0 && world.getBlockId(x, y + 1, z) != slabBlock)
                         {
@@ -212,9 +213,9 @@ public class WorldFeatureLabyrinth extends WorldFeature
     private boolean canReplace(World world, int x, int y, int z){
         if(y <= 11)
             return false;
-        if(world.getBlockId(x, y, z) == (brickBlockA) || world.getBlockId(x, y, z) == Block.planksOak.id || world.getBlockId(x, y, z) == Block.cobweb.id || world.getBlockId(x, y, z) == Block.bookshelfPlanksOak.id || world.getBlockId(x, y, z) == Block.mobspawner.id || world.getBlockId(x, y, z) == brickBlockB )
+        if(world.getBlockId(x, y, z) == (brickBlockA) || world.getBlockId(x, y, z) == Blocks.PLANKS_OAK.id || world.getBlockId(x, y, z) == Blocks.COBWEB.id || world.getBlockId(x, y, z) == Blocks.BOOKSHELF_PLANKS_OAK.id || world.getBlockId(x, y, z) == Blocks.MOBSPAWNER.id || world.getBlockId(x, y, z) == brickBlockB )
             return false;
-        if(world.getBlockId(x, y, z) == Block.motionsensorIdle.id || world.getBlockId(x, y, z) == Block.dispenserCobbleStone.id || world.getBlockId(x, y, z) == Block.motionsensorActive.id) {
+        if(world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_IDLE.id || world.getBlockId(x, y, z) == Blocks.DISPENSER_COBBLE_STONE.id || world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_ACTIVE.id) {
             world.removeBlockTileEntity(x, y, z);
             world.setBlockWithNotify(x, y, z, 0);
             return true;
@@ -299,7 +300,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                             else world.setBlockWithNotify(x, y, z, 0);
                         }
                         if(y == blockY + (height - 1) && !zWallCheck && !xWallCheck && random.nextInt(20)==0)
-                            world.setBlockWithNotify(x, y, z, Block.cobweb.id);
+                            world.setBlockWithNotify(x, y, z, Blocks.COBWEB.id);
                     }
                 }
             }
@@ -369,21 +370,21 @@ public class WorldFeatureLabyrinth extends WorldFeature
         int chestX = blockX + random.nextInt(size-1) - (size-1);
         int chestZ = blockZ + random.nextInt(size-1) - (size-1);
         if(canReplace(world, chestX, blockY-2, chestZ)) {
-            world.setBlockWithNotify(chestX, blockY - 1, chestZ, Block.chestPlanksOak.id);
-            TileEntityChest tileentitychest = (TileEntityChest) world.getBlockTileEntity(chestX, blockY - 1, chestZ);
+            world.setBlockWithNotify(chestX, blockY - 1, chestZ, Blocks.CHEST_PLANKS_OAK.id);
+            ChestBlockEntity tileentitychest = (ChestBlockEntity) world.getBlockEntity(chestX, blockY - 1, chestZ);
             int k4 = 0;
             while (k4 < 10) {
                 ItemStack itemstack = pickCheckLootItem(random);
                 if (itemstack != null) {
-                    tileentitychest.setInventorySlotContents(random.nextInt(tileentitychest.getSizeInventory()), itemstack);
+                    tileentitychest.setItem(random.nextInt(tileentitychest.getContainerSize()), itemstack);
                 }
                 k4++;
             }
         }
         if (doSpawner)
         {
-            world.setBlockWithNotify(blockX, blockY-1, blockZ, Block.mobspawner.id);
-            TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockTileEntity(blockX, blockY-1, blockZ);
+            world.setBlockWithNotify(blockX, blockY-1, blockZ, Blocks.MOBSPAWNER.id);
+            MobSpawnerBlockEntity tileentitymobspawner = (MobSpawnerBlockEntity)world.getBlockEntity(blockX, blockY-1, blockZ);
             if(tileentitymobspawner != null)
                 tileentitymobspawner.setMobId(pickMobSpawner(random));
         }
@@ -415,7 +416,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         }
                         else if (yWallCheck) {
                             if((x > blockX-2 && x < blockX+2) || (z > blockZ-2 && z < blockZ+2))
-                                world.setBlockWithNotify(x, y, z, Block.planksOak.id);
+                                world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id);
                             else if (random.nextInt(5) == 0)
                                 world.setBlockWithNotify(x, y, z, wallBlockB);
                             else
@@ -435,12 +436,12 @@ public class WorldFeatureLabyrinth extends WorldFeature
                                     && (z <= blockZ - 1 || z >= blockZ + 1)
                                     && y < blockY + 2) {
                                 if(xRoom % 2 == 0)
-                                    world.setBlockWithNotify(x, y, z, Block.bookshelfPlanksOak.id);
+                                    world.setBlockWithNotify(x, y, z, Blocks.BOOKSHELF_PLANKS_OAK.id);
                                 else
                                     if (random.nextInt(5) == 0)
-                                        world.setBlockWithNotify(x, y, z, Block.logOakMossy.id);
+                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK_MOSSY.id);
                                     else
-                                        world.setBlockWithNotify(x, y, z, Block.logOak.id);
+                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK.id);
                             }
                             else
                                 world.setBlockWithNotify(x, y, z, 0);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index bfed04599..5e50c5f3f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
@@ -10,7 +11,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Material, Block, 
-//            EnumSkyBlock, BlockGrass
+//            EnumSkyBlock, GrassBlock
 
 public class WorldFeatureLake extends WorldFeature
 {
@@ -21,7 +22,7 @@ public class WorldFeatureLake extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
     	Block liquid = Block.blocksList[liquidId];
     	Biome biome = world.getBlockBiome(x, y, z);
@@ -81,7 +82,7 @@ public class WorldFeatureLake extends WorldFeature
                     {
                         return false;
                     }
-                    if (world.getBlockId(x + dx, y + dy, z + dz) == Block.ice.id)
+                    if (world.getBlockId(x + dx, y + dy, z + dz) == Blocks.ICE.id)
                     {
                     	return false;
                     }
@@ -113,9 +114,9 @@ public class WorldFeatureLake extends WorldFeature
             {
                 for(int dy = 4; dy < 8; dy++)
                 {
-                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Block.dirt.id && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
+                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Blocks.DIRT.id && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
                     {
-                        world.setBlock(x + dx, (y + dy) - 1, z + dz, Block.grass.id);
+                        world.setBlock(x + dx, (y + dy) - 1, z + dz, Blocks.GRASS.id);
                     }
                 }
 
@@ -134,7 +135,7 @@ public class WorldFeatureLake extends WorldFeature
                         boolean flag1 = !shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && (dx < 15 && shouldPlaceLiquid[((dx + 1) * 16 + dz) * 8 + dy] || dx > 0 && shouldPlaceLiquid[((dx - 1) * 16 + dz) * 8 + dy] || dz < 15 && shouldPlaceLiquid[(dx * 16 + (dz + 1)) * 8 + dy] || dz > 0 && shouldPlaceLiquid[(dx * 16 + (dz - 1)) * 8 + dy] || dy < 7 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy + 1)] || dy > 0 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy - 1)]);
                         if(flag1 && (dy < 4 || random.nextInt(2) != 0) && world.getBlockMaterial(x + dx, y + dy, z + dz).isSolid())
                         {
-                            world.setBlock(x + dx, y + dy, z + dz, world.getWorldType().getFillerBlock());
+                            world.setBlock(x + dx, y + dy, z + dz, world.getWorldType().getFillerBlockId());
                         }
                     }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index d82871189..57877d595 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -17,34 +18,34 @@ public class WorldFeatureLiquid extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Block.stone.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.STONE.id)
         {
             return false;
         }
-        if(world.getBlockId(x, y - 1, z) != Block.stone.id)
+        if(world.getBlockId(x, y - 1, z) != Blocks.STONE.id)
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Block.stone.id)
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.STONE.id)
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Block.stone.id)
+        if(world.getBlockId(x - 1, y, z) == Blocks.STONE.id)
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Block.stone.id)
+        if(world.getBlockId(x + 1, y, z) == Blocks.STONE.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Block.stone.id)
+        if(world.getBlockId(x, y, z - 1) == Blocks.STONE.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Block.stone.id)
+        if(world.getBlockId(x, y, z + 1) == Blocks.STONE.id)
         {
             l++;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
index 61d5ef9a9..3cff97531 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -15,9 +15,9 @@ public class WorldFeatureMeadow extends WorldFeature
     }
 
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z)
+    public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BaseLeavesBlock) && y > 0; y--) { }
         for(int i1 = 0; i1 < 128; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
